#include "..\..\mqbench.h"

int g_MultiThreadSupport = TRUE;

void GetTime_OS(TIMESTRUCT_OS* pTS) {
	GetSystemTimeAsFileTime((FILETIME*)pTS);
}

double GetElapsedTime_OS(TIMESTRUCT_OS* pStartTime, TIMESTRUCT_OS* pEndTime) {
	return ((double)(*pEndTime - *pStartTime)) / 10000000;
}

void CreateEvents_OS(void)
{
	g_hWaitToStart = CreateEvent(  
				0,			/* no security attributes */
				TRUE,		/* use manual-reset event */
				FALSE,	/* event is reset initally */
				NULL		/* unnamed event */
				);

	if (g_hWaitToStart == NULL)
	{
		ErrorExit("CreateEvent failed", GetLastError());
	}

	g_hStart = CreateEvent(  
				0,			/* no security attributes */
				TRUE,		/* use manual-reset event */
				FALSE,	/* event is reset initally */
				NULL		/* unnamed event */
				);

	if (g_hStart == NULL)
	{
		ErrorExit("CreateEvent failed", GetLastError());
	}

	g_hEnd  = CreateEvent(  
				0,			/* no security attributes */
				TRUE,		/* use manual-reset event */
				FALSE,	/* event is reset initally */
				NULL		/* unnamed event */
				);
	if (g_hEnd == NULL)
	{
		ErrorExit("CreateEvent failed", GetLastError());
	}

	g_hSync1  = CreateEvent(  
				0,			/* no security attributes */
				TRUE,		/* use manual-reset event */
				FALSE,	/* event is reset initally */
				NULL		/* unnamed event */
				);
	if (g_hSync1 == NULL)
	{
		ErrorExit("CreateEvent failed", GetLastError());
	}

	g_hSync2  = CreateEvent(  
				0,			/* no security attributes */
				TRUE,		/* use manual-reset event */
				FALSE,	/* event is reset initally */
				NULL		/* unnamed event */
				);
	if (g_hSync2 == NULL)
	{
		ErrorExit("CreateEvent failed", GetLastError());
	}
}

void CloseEvents_OS(void) {
	CloseHandle(g_hWaitToStart);
	CloseHandle(g_hStart);
	CloseHandle(g_hEnd);
	CloseHandle(g_hSync1);
	CloseHandle(g_hSync2);
}

void Sleep_OS(ULONG ulMilliSeconds) {
  Sleep(ulMilliSeconds);
}

void SetEvent_OS(EVENTOBJ_OS hEvent) {
  SetEvent(hEvent);
}

void ResetEvent_OS(EVENTOBJ_OS hEvent) {
  ResetEvent(hEvent);
}

void WaitForEvent_OS(EVENTOBJ_OS hEvent) {
  WaitForSingleObject(hEvent, INFINITE);
}

LONG InterlockedDecrement_OS(LONG* pDecVar) {
	return InterlockedDecrement(pDecVar);
}

LONG InterlockedExchange_OS(LONG* pExchgVar, LONG NewVal) {
  return InterlockedExchange(pExchgVar, NewVal);
}

void StartThreads_OS(void) {
  UINT i;

	for(i = 0; i < g_Params.ulThreadNum; i++)
	{
		HANDLE hThread;
		DWORD dwThreadId;

		hThread = CreateThread(
					NULL,		/* no thread security attributes */
					0,			/* use default thread stack size */
					TestThread, /* the thread function */
					(PVOID)i,			/* pass the thread number as the argument */
					0,			/* creation flags, create running thread */
					&dwThreadId	/* thread identifier */
					);
		if (hThread == NULL)
		{
			ErrorExit("Create Thread failed", GetLastError());
		}

    /* wait for thread to be in a started state */
	  WaitForEvent_OS(g_hWaitToStart);

    /* reset the event */
	  ResetEvent_OS(g_hWaitToStart);

		CloseHandle(hThread);
	}
}
